"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatError = void 0;
const formatError = (error) => {
    if (error instanceof Error) {
        return error;
    }
    if (typeof error === "string") {
        return new Error(error);
    }
    if (typeof error === "object") {
        return new Error(JSON.stringify(error, null, 2));
    }
    return new Error(`Unknown error: ${error}`);
};
exports.formatError = formatError;
