import * as React from 'react';
import { getFormattedTimeDelta } from './utils';
interface DropContext {
    progress: number | null;
    timeRemaining: number;
    isComplete: boolean;
    endTimestamp: number;
    startTimestamp: number | null;
    update: () => void;
    humanTimeRemaining: ReturnType<typeof getFormattedTimeDelta>;
    countdownState: 'running' | 'complete' | 'exiting';
    setCountdownState: (state: 'running' | 'complete' | 'exiting') => void;
}
declare const useDrop: import("zustand/context").UseContextStore<DropContext>;
declare type DropProviderProps = {
    children?: React.ReactNode;
    countdownChildren?: React.ReactNode;
    endDate: Date | number;
    startDate?: Date | number;
    exitDelay?: number;
};
declare const DropProvider: ({ children, endDate, startDate, exitDelay, countdownChildren }: DropProviderProps) => JSX.Element;
export { DropContext, DropProvider, useDrop };
